use 5.12.0;
use File::Slurp;
use File::Find ; 
use Cwd ; 
use FindBin '$Bin';

my $topDir = "/Users/Henry/Documents/WACS/en_tw";
my (%page);
my (@filesToRun, @entryList, @workList) = ();
my $filePattern = '.md' ; 

open LOG, ">$Bin/Logs/log.txt" or die "$!";

find( sub { push @filesToRun, $File::Find::name  if ( m/^(.*)$filePattern$/ ) }, $topDir) ;

say "Pairing entries";

foreach  my $file ( @filesToRun  ) {
	my ($entry, $shortFile) = ("", $file);
	my (@theseEntries);
	#print LOG "$shortFile\t";
	$shortFile =~ s/^[^\n]*\/([^\n\/\\\.]*)\.md$/$1/;
	#say LOG "$shortFile: ";
	my $fileText = read_file("$file", binmode => 'utf8');
	#say LOG $fileText;
	if ($fileText =~ /^# ([^\n]*)\n/) {
		my $entries = $1;
		#say LOG "$entries";
		@theseEntries = split /, /, $entries;
		push (@entryList, @theseEntries);
	}
	#say LOG "$shortFile: @entryList";
	foreach my $slice (@theseEntries) {
		$page{$slice} = $shortFile;
		say LOG "$slice\t$page{$slice}";
	}
	#say LOG "\n";
}

say LOG "<>";

@workList = reverse sort {  substr($a,0,1) <=> substr($b,0,1)
				 || length($a) <=> length($b)
				 || $a <=> $b }
				@entryList;

say "Reading exceptions file";

my $fileText = read_file("/Users/Henry/Documents/WACS/Tips_and_Hacks/MAST_tW_PDF_Updater/FilesForUpdates/Exceptions/Exceptions.txt", binmode => 'utf8');

$" = "\n";
say LOG "===Entry list===\n@entryList\n===";

foreach my $entry (@workList) {
	say $entry;
	$fileText =~ s/(\n[^#\t\n]*\t[^\t\n]*\t$entry)\n/$1\t$page{$entry}\n/g;
}

say LOG "\n===Work list===\n@workList\n===";

open(OUT, ">/Users/Henry/Documents/WACS/Tips_and_Hacks/MAST_tW_PDF_Updater/FilesForUpdates/Output/New.exceptions.txt") or die "$1";

say OUT $fileText;

close OUT;

close LOG;

say "Done.";
