# Builds easily searchable files from current OGNT and MAST-HB XML file
# Takes verse at a time from slurped file
use 5.18.0;
use File::Slurp;
use File::Find ; 
use Cwd ; 
use utf8;
#use open IN => ":utf8", OUT => ":utf8";
use open IO => ":utf8";

my (@folders) = ("/Users/Henry/Documents/WACS/MAST_HB", "/Users/Henry/Documents/WACS/OGNT");
my (%order, %long);
my ($lang, $outText) = ("H", "");

while (<DATA>) {
	chomp;
	if (/^([^\t]*)\t([^\t]*)\t(.*)$/) {
		$order{$1} = $3;
		$long{$2} = $3;
	}
}

open LOG, ">:utf8", "Logs/log.txt" or die;
open OUT, ">:utf8", "Output/Original_languages.txt" or die;

foreach my $folder (@folders) {
	say LOG "$folder";
	#system "cd $folder;xml val *.xml;echo 'Continue? (Control + C to quit, Enter to continue)';read name;";
	my ($topDir) = ($folder);
	
	if ($folder =~ /OGNT/) {$lang = "G"}
	
	my @filesToRun = ();
	my $filePattern = '*.xml' ; 
	find( sub { push @filesToRun, $File::Find::name if ( m/^(.*)$filePattern$/ ) }, $topDir) ;
	@filesToRun = sort @filesToRun;
	foreach  my $file ( @filesToRun  ) {
	   say LOG $file;
	   my $fileText = read_file("$file", binmode => 'utf8');
	   my ($bk, $ch, $vs, $lemma, $word, $nbk, $nch, $nvs, $previous, $current, $interruption, $next, $verse, $thisBookText, $prevVsText, $holdText, $thisVsText, $nextVsText, $oldHold, $verseID);
	   while ($fileText =~ /<verse osisID="((.*?)\.(\d+)\.(\d+))".*?<\/verse>/spg) {
		#say LOG "$1.$2.$3";
			($verse, $verseID, $current) = ($&, $1, $1);
			#say LOG $verse;
			$previous = $current;
#			say LOG "$current:\n$verse";
			#say LOG "\$current: $current";
			my $verseText;
			
  			if ($verse =~ /<note>KJV:(([^\.]*?)\.([^\.]*?).([^\.<]*?))<\/note>/p) { # Occurs only in OT
				($interruption, $nbk, $nch, $nvs) = ($1, $2, $3, $4);
				say LOG "\n<0>\t\$current: $current\t\$interruption: $interruption";
				if ($verse =~ s/(<verse osisID=")$current(">\n)[^<]*<note>KJV:$interruption<\/note>/$1$interruption$2/s) { # Complete renumber of verse
					$current = $interruption;
					say LOG "<1>\t\$current: $current\t\$interruption: $interruption";
					$verseText = GetContent($verse);
					$verseText = "$oldHold$verseText";
					$oldHold = "";
					say LOG "<1.5>\t\$verseText\n$verseText";
				}
				elsif ($interruption ne $current || $verse =~ /<note>KJV:(.*)\.(.*).(.*)<\/note>/s) { # New verse begins here
					($thisVsText, $nextVsText) = ($`, $');
					say LOG "<2>\t\$thisVsText:\n$thisVsText\t\$nextVsText:\n$nextVsText";
				   	$thisVsText = GetContent($thisVsText);
					$nextVsText = GetContent($nextVsText);
					say LOG "<2.5>\t\$thisVsText:\n$thisVsText\t\$nextVsText:\n$nextVsText";
					$verseText .= "$oldHold\n$current\t$thisVsText ";
					$oldHold = "$nextVsText ";
				}
				elsif ($interruption eq $current || $verse =~ /<note>KJV:(.*)\.(.*).(.*)<\/note>/s) { # Previous verse continues here
					($prevVsText, $thisVsText) = ($`, $');
					say LOG "<3>\t\$prevVsText:\n$prevVsText\n\$thisVsText:\n$thisVsText";
			#		$prevVsText = GetContent($prevVsText);
			#		$thisVsText = GetContent($thisVsText);
			#		$verseText .= "$oldHold\n$current\t$thisVsText";
			#		$oldHold = "";
				}
			}
			else {
				$verseText = GetContent($verse);
			}
			say LOG "<4>\t\$current: $current\t\$verseText\n$verseText";
			if ($current =~ /^([^\.]*)\.([^\.]*)\.([^\.]*)$/) {
				($bk, $ch, $vs) = ($long{$1}, $2, $3);
			}
			
			$verseText = "$bk $ch:$vs\t$verseText";
			say LOG "<4.5>\t\$current: $current\t\$verseText\n$verseText";
			$thisBookText .= "\n$verseText";
			$oldHold = $holdText
	   }
	   $thisBookText =~ s/</<$lang/g;
	   $outText .= "$thisBookText\n";
	} 


}

say OUT $outText;

close OUT;
close LOG;

print "\n\tDone.";

sub GetContent {
	my ($text, $returnText) = ($_[0], "");
	my @array;
	say LOG "<10>\t\$text\n$text";
	while ($text =~ /<w [^<>]*lemma="([^"]*)"[^>]*>([^<]*)<\/w>/g) {
		my ($lemma, $OL) = ($1, $2);
		$lemma =~ s/[^\d"]*(\d+)[^\d"]*/$1/;
		$returnText .= "$OL <$lemma> "
	}
	say LOG "<11>\t\$returnText\n$returnText";
	return $returnText
}

__DATA__
01	gen	Genesis
02	exo	Exodus
03	lev	Leviticus
04	num	Numbers
05	deu	Deuteronomy
06	jos	Joshua
07	jdg	Judges
08	rut	Ruth
09	1sa	1 Samuel
10	2sa	2 Samuel
11	1ki	1 Kings
12	2ki	2 Kings
13	1ch	1 Chronicles
14	2ch	2 Chronicles
15	ezr	Ezra
16	neh	Nehemiah
17	est	Esther
18	job	Job
19	psa	Psalms
20	pro	Proverbs
21	ecc	Ecclesiastes
22	sng	Song of Solomon
23	isa	Isaiah
24	jer	Jeremiah
25	lam	Lamentations
26	ezk	Ezekiel
27	dan	Daniel
28	hos	Hosea
29	jol	Joel
30	amo	Amos
31	oba	Obadiah
32	jon	Jonah
33	mic	Micah
34	nam	Nahum
35	hab	Habakkuk
36	zep	Zephaniah
37	hag	Haggai
38	zec	Zechariah
39	mal	Malachi
41	mat	Matthew
42	mrk	Mark
43	luk	Luke
44	jhn	John
45	act	Acts
46	rom	Romans
47	1co	1 Corinthians
48	2co	2 Corinthians
49	gal	Galatians
50	eph	Ephesians
51	php	Philippians
52	col	Colossians
53	1th	1 Thessalonians
54	2th	2 Thessalonians
55	1ti	1 Timothy
56	2ti	2 Timothy
57	tit	Titus
58	phm	Philemon
59	heb	Hebrews
60	jas	James
61	1pe	1 Peter
62	2pe	2 Peter
63	1jn	1 John
64	2jn	2 John
65	3jn	3 John
66	jud	Jude
67	rev	Revelation
