# Converts internal verse refs to WA MAST abbreviations
use 5.12.0;
use File::Slurp;
use File::Find ; 
use Cwd ; 
use utf8;
#use open IN => ":utf8", OUT => ":utf8";
use open IO => ":utf8";

my ($oldName, $newName);
my $topDir = "/Users/Henry/Documents/WACS/MAST_HB";
#my $topDir = "/Users/Henry/Documents/WACS/MAST_HB";
my (%new_name);

while (<DATA>) {
	chomp;
	if (/([^\t]*)\t([^\t]*)/) {
		($oldName, $newName) = ($1, lc $2);
		$new_name{$oldName} = $newName
	}
}


my @filesToRun = ();
my $filePattern = '*.xml' ; 
find( sub { push @filesToRun, $File::Find::name if ( m/^(.*)$filePattern$/ ) }, $topDir) ;

foreach  my $file ( @filesToRun  ) {
	say $file;
    my $fileText = read_file("$file", binmode => 'utf8');
	foreach my $key (sort keys %new_name) {
		$fileText =~ s/(osisID=")$key(\.\d+\.\d+")/$1$new_name{$key}$2/g;
		$fileText =~ s/(<note>KJV:)$key(\.\d+\.\d+<\/note>)/$1$new_name{$key}$2/g;
		$fileText =~ s/(<\/w>)\n          <seg/$1<seg/g;
	}
	open(OUT, ">:utf8", "$file") or die "$file:\n$!";
	say OUT $fileText;
	close OUT;
} 
print "Done.\n\nBe sure to validate XML by running\nxml val *.xml\nin both OGNT and MAST-HB directories before running\nBuild_OL_files_from_XML.pl\n"

__DATA__
Gen	GEN
Exod	EXO
Lev	LEV
Num	NUM
Deut	DEU
Josh	JOS
Judg	JDG
Ruth	RUT
1Sam	1SA
2Sam	2SA
1Kgs	1KI
2Kgs	2KI
1Chr	1CH
2Chr	2CH
Ezra	EZR
Neh	NEH
Esth	EST
Job	JOB
Ps	PSA
Prov	PRO
Eccl	ECC
Song	SNG
Isa	ISA
Jer	JER
Lam	LAM
Ezek	EZK
Dan	DAN
Hos	HOS
Joel	JOL
Amos	AMO
Obad	OBA
Jonah	JON
Mic	MIC
Nah	NAM
Hab	HAB
Zeph	ZEP
Hag	HAG
Zech	ZEC
Mal	MAL
