use 5.12.0;
use File::Slurp;
use File::Find ; 
use Cwd ; 
use utf8;
#use open IN => ":utf8", OUT => ":utf8";
use open IO => ":utf8";

open LOG, ">:utf8", "Logs/log.log" or die;
open OUT, ">:utf8", "Output/output.txt" or die;

my $topDir = "/Users/Henry/Documents/WACS/en_tw/bible";
my $filePattern = '\.md' ;
my %foundEntries;
my @theseEntries;

my @filesToRun = ();
find( sub { push @filesToRun, $File::Find::name  if ( m/^(.*)$filePattern$/ ) }, $topDir) ;

foreach  my $file ( @filesToRun  ) {
	say LOG $file;
	my $fileText = read_file("$file", binmode => 'utf8');
	my $theseEntries;
	if ($fileText =~ /^# ([^\n]*?)\n/) {
		$theseEntries = $1;
		@theseEntries = split /, /, $theseEntries;
		ParseEntries();
	}
} 

close OUT;
close LOG;

print "\n\tDone.";

# ============

sub ParseEntries {
	foreach my $entry (@theseEntries) {
		$entry =~ s/ \([^\)]*\)//g;
		if (exists $foundEntries{$entry}) {
			say OUT $entry;
		} else {
			$foundEntries{$entry} = $entry
		}
	}
	@theseEntries = "";
}