use 5.12.0;
use File::Slurp;
use File::Find ; 
use Cwd ; 

my (%long);
my (@topDirs) = ('/Users/Henry/Documents/WACS/MAST_HB', '/Users/Henry/Documents/WACS/OGNT');
my $outText;

open LOG, ">Logs/log.txt" or die;
open(OUT, ">Output/Lemmas.txt") or die "$!";

GetBookNames();
ProcessFiles();

say OUT $outText;

close OUT;
close LOG;

say "Done.";

sub ProcessFiles {
	foreach my $topDir (@topDirs) {
		say $topDir;
		my @filesToRun = ();
		my $filePattern = '*.xml' ; 
		find( sub { push @filesToRun, $File::Find::name if ( m/^(.*)$filePattern$/ ) }, $topDir) ;

		@filesToRun = sort @filesToRun;

		foreach my $file ( @filesToRun  ) {
			say $file;
			open(INPUT, "$file") or die "$!";
				while (<INPUT>) {
					chomp;
					if (/<verse osisID="(.*)\.(\d{1,3})\.(\d{1,3})">/) {
						my ($thisBk, $thisCh, $thisVs) = ($1, $2, $3);
						$thisBk = $long{$thisBk};
						$outText .= "\n$thisBk $thisCh:$thisVs: ";
					}
					elsif (/lemma="[^\d]*(\d{1,4})[^\d]*"/) {
						my $thisLemma = $1;
						$outText .= "$thisLemma, "
					}
				}
				
			close INPUT;
		} 
	}
	$outText =~ s/, $//g;
	$outText =~ s/^\n//;
}

sub GetBookNames {
	while (<DATA>) {
		chomp;
		if (/^([^\t\n]*)\t([^\t\n]*)$/) {
			$long{$1} = $2
		}
	}
}


__DATA__
gen	Genesis
exo	Exodus
lev	Leviticus
num	Numbers
deu	Deuteronomy
jos	Joshua
jdg	Judges
rut	Ruth
1sa	1 Samuel
2sa	2 Samuel
1ki	1 Kings
2ki	2 Kings
1ch	1 Chronicles
2ch	2 Chronicles
ezr	Ezra
neh	Nehemiah
est	Esther
job	Job
psa	Psalms
pro	Proverbs
ecc	Ecclesiastes
sng	Song of Solomon
isa	Isaiah
jer	Jeremiah
lam	Lamentations
ezk	Ezekiel
dan	Daniel
hos	Hosea
jol	Joel
amo	Amos
oba	Obadiah
jon	Jonah
mic	Micah
nam	Nahum
hab	Habakkuk
zep	Zephaniah
hag	Haggai
zec	Zechariah
mal	Malachi
mat	Matthew
mrk	Mark
luk	Luke
jhn	John
act	Acts
rom	Romans
1co	1 Corinthians
2co	2 Corinthians
gal	Galatians
eph	Ephesians
php	Philippians
col	Colossians
1th	1 Thessalonians
2th	2 Thessalonians
1ti	1 Timothy
2ti	2 Timothy
tit	Titus
phm	Philemon
heb	Hebrews
jas	James
1pe	1 Peter
2pe	2 Peter
1jn	1 John
2jn	2 John
3jn	3 John
jud	Jude
rev	Revelation
