use 5.12.0;
use utf8;
use Cwd;
use File::Slurp;
use File::Basename;
use FindBin '$Bin';
use open IO => ":utf8";
$| = 1;
$" = "\n";

my ($pwd, $d, $fileSpec) = ($Bin, "\\", "\.usfm");
if ($^O eq "linux" || $^O eq "darwin") {$d = "/"}

chdir $pwd;

my $html_tof = read_file("$Bin${d}Data${d}HTML_TOF.txt", binmode => 'utf8');

my $language = read_file("$Bin${d}Temp${d}Workdata.tmp", binmode => 'utf8');

my $title;

if ($language =~ /greek/) {
	$language = "greek"
} else {$language = "hebrew"}

my $fileText = read_file("$Bin${d}Temp${d}Strongs_raw.html", binmode => 'utf8');

	if ($fileText =~ /<title>([^<>]*)<\/title>/) {
		$title = $1;
	}

	my $short_title = $title;
	$short_title =~ s/^[^:]*: //;
	
	$html_tof =~ s/<\/head>/\t<title>$short_title<\/title>\n$&/;
	$html_tof =~ s/<body>/$&\n<p>$title<\/p>/;

	if ($language eq "greek") {
		
		if ($fileText =~ /(<div class="vheading2">(Thayer)'s Greek Lexicon<\/div>.*?)<div/) {
			#say $fileText; die:
			$fileText = "$html_tof$1</body></html>";
			$fileText =~ s/(<span class="greek2">)(.*?)(<\/span>)/$1<b>$2<\/b>$3/g;
		}
	}
	elsif ($language eq "hebrew") {
		if ($fileText =~ /(<div class="vheading2">Brown-Driver-Briggs.*?<\/iframe>)/) {
			my $gist = $1;
			$fileText = "$html_tof$gist</body></html>";
			$fileText =~ s/(<font class="hebrew.?">)(.*?)(<\/font>)/$1<font size="+1"><b>$2<\/b><\/font>$3/g;
		}
	}
	else {die}
	$fileText =~ s/<iframe[^<>]*>.*?<\/iframe>//g;
	$fileText =~ s/<([^ ]*)[^<>]*><\/\1>//g;
	$fileText =~ s/<font size="\+1" color="#552200"><b>[^<>]*<\/b><\/font>/<br \/>$&<br\/>/g;
	$fileText =~ s/<font class="hebrew2"><font size="\+1">/<font class="hebrew2"><font size="+3">/;
	$fileText =~ s/ — <em>[^<>]*<\/em>/\n<br \/>$&/g;
	$fileText =~ s/<p><br \/>/<p>/g;
	$fileText =~ s/(<p><font size="\+1" color="#552200"><b>\d+<\/b><\/font>)<br\/>/$1/g;
	open OUT, ">:utf8", "$Bin${d}Temp${d}Strongs.html" or die;
		say OUT $fileText;
	close OUT;

